#!/usr/bin/env python

import sys
from Numeric import *


def ahelp():
    print
    print "This program fixes bad database keywords for CosmosPipeline.py"  
    print
    print "-d   --disperser  DISPERSER_NAME"
    print "-db  --database   DATABASE_FILE"
    print "-f   --filter     FILTER_NAME"
    print "-ins --instrument INSTRMENT       chose the instrumnt you want to fix db for [imacs,ldss3]"
    print "-o   --object     OBJECT_NAME"
    print "-m   --mask       MASK_NAME"
    print "-r   --range      MIN-MAX"
    print

filter = None
disperser = None
mask = None
min,max = None,None
object = None
instrument = None
database = None

for n,arg in enumerate(sys.argv):
    if arg in ("-f","--filter"): filter = sys.argv[n+1]
    elif arg in ("-d","--disperser"): disperser = sys.argv[n+1]
    elif arg in ("-db","--database"): database = sys.argv[n+1]
    elif arg in ("-ins","--instrument"): instrument = sys.argv[n+1].strip()
    elif arg in ("-o","--object"): object = sys.argv[n+1]
    elif arg in ("-m","--mask"): mask = sys.argv[n+1]
    elif arg in ("-r","--range"):
        tr = sys.argv[n+1].split(",")
        #ranges = [(int(r.split("-")[0]),int(r.split("-")[1])+1) for r in tr]
        ranges = []
        for r in tr:
            el = r.split("-")
            min = int(el[0])
            #print len(el)
            if len(el) == 1: max = min+1
            elif len(el) == 2: max = int(el[1])+1
            ranges.append((min,max))
        #print ranges 
        #sys.exit()
        #tr = sys.argv[n+1].split("-")
        #min,max = int(tr[0]),int(tr[1])+1
    elif arg in ("-h","--help"):
        ahelp()
        sys.exit()

if not database and not instrument and (not filter or not disperser or not mask or not object): ahelp()
else:
    if instrument in "imacs":
        FILENAME_POS = 0
        DATE_POS = 1
        INSTRUMENT_POS = 3
        FILTER_POS = 4
        DISPERSR_POS = 5
        MASK_POS = 7
        DEWARORI_POS = 9
        OBJECT_POS = 10

        chips = 8

    elif instrument in "ldss3":
        FILENAME_POS = 0
        DATE_POS = 1
        INSTRUMENT_POS = 3
        # GRISM
        DISPERSR_POS = 5
        # None
        DEWARORI_POS = None 
        MASK_POS = 6 
        OBJECT_POS = 8
 
        chips = 2

    L = open(database,"r").readlines()
    #if not ran: 
    #    choice = raw_input("Are you sure you modify the all the database entries (default no)? ")
    #    if not choice: choice = "no"
    #    if choice.lower().strip[0] == "y":
    f = open("_".join([database.replace(".db","").replace("_fix",""),"fix.db"]),"w")
    for l in L: 
        if l[0] == "#": f.write(l);continue
        ll = l.split("\t")
        for ran in ranges:
            min,max = ran
            for k in arange(min,max):
                for c in arange(chips+1):
                    if ll[0].split("/")[-1] == "ccd%04dc%i.fits" % (k,c): 
                        if filter: ll[FILTER_POS] = filter
                        if disperser: ll[DISPERSR_POS] = disperser
                        if mask: ll[MASK_POS] = mask
                        if object: ll[OBJECT_POS] = object + '\n'
                        l = "\t".join(ll)
                        print l
        f.write(l)
    f.close()
