#!/usr/bin/env python

import pgplot as PG
import sys
from MLab import diff
from FITS import *
from basics import *
from Multipack import *

def help():
    print
    print "skyline-plot.py fitsfile skylines"
    print
    print "Make sure the line list is sorted before running skyline-plot.py"
    print "Otherwise it will give you a weird error:"
    print """
Traceback (most recent call last):
  File "/home/gwalth/python.linux/scripts/skyline-plot.py", line 63, in ?
    plot_spec(fitsfile,skylines)
  File "/home/gwalth/python.linux/scripts/skyline-plot.py", line 42, in plot_spec
    skyl = splev(skywaves,tck)
  File "/data1/mifune/kelson/Python.Linux/lib/python2.3/site-packages/multipack/fitpack.py", line 257, in splev
    if ier==10: raise ValueError,"Invalid input data"
ValueError: Invalid input data"""
    print

def plot_spec(fitsfile,skylines,ps):
    f = FITS(fitsfile)
    spec = f.data()

    crval1 = f["crval1"]
    cdelt1 = f["cdelt1"]
    crpix1 = f["crpix1"]
    dcflag = f["dc-flag"]
    naxis1 = f["naxis1"]

    wavelengths = (arange(naxis1)+1.0-crpix1)*cdelt1 + crval1
    if dcflag == 1: wavelengths = power(10,wavelengths)

    skylinesdata = [item.split() for item in open(skylines,"r")]
    skywaves = [float(skyline[0]) for skyline in skylinesdata]
    skyids = [" ".join([skyline[0]]+skyline[1:]) for skyline in skylinesdata]
    skyn = len(skyids)
    ny = 4

    if ps:PG.opendev("%s/vcps" % (fitsfile.replace(".fits",".ps")),nx=1,ny=ny,land=2,size=8)
    else: PG.opendev("/xs",nx=1,ny=ny,land=2,size=8)  # Plot to screen
    w0,w1 = extrema(wavelengths)
    dwr = (w1-w0)/ny

    tck = splrep(wavelengths,spec,s=0,k=3)
    skyl = splev(skywaves,tck)

    for wbin in range(ny):
       wrange = clip([w0+wbin*dwr-50, w0+(wbin+1)*dwr+50], w0, w1)
       print wrange
       spec1 = compress(between(wavelengths,wrange[0],wrange[1]),spec)
       extr = extrema(spec1)
       ran = diff(extr)[0]
       ymar = extr[0]-0.05*ran, extr[1]+0.70*ran
       PG.newbox(wrange,ymar,ch=2.0)
       PG.xlabel("\gl",ch=2.0)
       PG.ylabel("I",ch=2.0)
       PG.drawln(wavelengths,spec,lw=1,ls=1,ci=1)
       skyh = (ymar[1]-0.05*ran)*ones((skyn,))
       skyp = 0.25*(skyh-skyl) + skyl
       PG.markpts(wrange[0],wrange[1],ymar[0],ymar[1],skywaves,skyp,skyids,\
       	ch=1.5,ci=1,ang=90,fj=0,lw=1)
       [PG.drawln([skywaves[j],skywaves[j]],[skyl[j],skyp[j]],ls=4) for j in range(skyn)]

fitsfile = None
skylines = None
ps = False

n = 0 
for arg in sys.argv:
    if arg in ("-f","--fits"): fitsfile = sys.argv[n+1]
    elif arg in ("-s","--skylines"): skylines = sys.argv[n+1]
    elif arg in ("--ps"): ps = True
    elif arg in ("-h","--help"):
        help()
        sys.exit()
    n += 1
if fitsfile is not None and skylines is not None:
    plot_spec(fitsfile,skylines,ps)
else:
    help()
    sys.exit()
